---
title: HTMLVideoElement
slug: Web/API/HTMLVideoElement
tags:
  - API
  - HTML DOM
  - HTMLVideoElement
  - Interface
  - Reference
  - Video
---
<div>{{APIRef("HTML DOM")}}</div>

<p>The <strong><code>HTMLVideoElement</code></strong> interface provides special properties and methods for manipulating video objects. It also inherits properties and methods of {{domxref("HTMLMediaElement")}} and {{domxref("HTMLElement")}}.</p>

<p>The list of <a href="/en-US/docs/HTML/Supported_media_formats">supported media formats</a> varies from one browser to the other. You should either provide your video in a single format that all the relevant browsers supports, or provide multiple video sources in enough different formats that all the browsers you need to support are covered.</p>

<p>{{InheritanceDiagram(600, 140)}}</p>

<h2 id="Properties">Properties</h2>

<p><em>Inherits properties from its ancestor interfaces, </em><em>{{domxref("HTMLMediaElement")}}, and </em><em>{{domxref("HTMLElement")}}.</em></p>

<dl>
 <dt>{{domxref("HTMLVideoElement.height")}}</dt>
 <dd>Is a {{domxref("DOMString")}} that reflects the {{htmlattrxref("height", "video")}} HTML attribute, which specifies the height of the display area, in CSS pixels.</dd>
 <dt>{{domxref("HTMLVideoElement.poster")}}</dt>
 <dd>Is a {{domxref("DOMString")}} that reflects the {{htmlattrxref("poster", "video")}} HTML attribute, which specifies an image to show while no video data is available.</dd>
 <dt>{{domxref("HTMLVideoElement.videoHeight")}} {{readonlyInline}}</dt>
 <dd>Returns an unsigned integer value indicating the intrinsic height of the resource in CSS pixels, or 0 if no media is available yet.</dd>
 <dt>{{domxref("HTMLVideoElement.videoWidth")}} {{readonlyInline}}</dt>
 <dd>Returns an unsigned integer value indicating the intrinsic width of the resource in CSS pixels, or 0 if no media is available yet.</dd>
 <dt>{{domxref("HTMLVideoElement.width")}}</dt>
 <dd>Is a {{domxref("DOMString")}} that reflects the {{htmlattrxref("width", "video")}} HTML attribute, which specifies the width of the display area, in CSS pixels.</dd>
 <dt>{{DOMxRef("HTMLVideoElement.autoPictureInPicture")}}</dt>
 <dd>The <code>autoPictureInPicture</code> attribute will automatically enter and leave the picture-in-picture mode for a video element when the user switches tab and/or applications</dd>
 <dt>{{DOMxRef("HTMLVideoElement.disablePictureInPicture")}}</dt>
 <dd>The <code>disablePictureInPicture</code> property will hint the user agent to not suggest the picture-in-picture to users or to request it automatically</dd>
</dl>

<h3 id="Gecko-specific_properties">Gecko-specific properties</h3>

<dl>
 <dt>{{domxref("HTMLVideoElement.mozParsedFrames")}} {{Non-standard_Inline}}{{ReadOnlyInline}}</dt>
 <dd>Returns an <code>unsigned long</code> with the count of video frames that have been parsed from the media resource.</dd>
 <dt>{{domxref("HTMLVideoElement.mozDecodedFrames")}} {{Non-standard_Inline}}{{ReadOnlyInline}}</dt>
 <dd>Returns an <code>unsigned long</code> with the count of parsed video frames that have been decoded into images.</dd>
 <dt>{{domxref("HTMLVideoElement.mozPresentedFrames")}} {{Non-standard_Inline}}{{ReadOnlyInline}}</dt>
 <dd>Returns an <code>unsigned long</code> with the count of decoded frames that have been presented to the rendering pipeline for painting.</dd>
 <dt>{{domxref("HTMLVideoElement.mozPaintedFrames")}} {{Non-standard_Inline}}{{ReadOnlyInline}}</dt>
 <dd>Returns an <code>unsigned long</code> with the count of presented frames which were painted on the screen.</dd>
 <dt>{{domxref("HTMLVideoElement.mozFrameDelay")}} {{Non-standard_Inline}}{{ReadOnlyInline}}</dt>
 <dd>Returns an <code>double</code> with the time which the last painted video frame was late by, in seconds.</dd>
 <dt>{{domxref("HTMLVideoElement.mozHasAudio")}} {{Non-standard_Inline}}{{ReadOnlyInline}}</dt>
 <dd>Returns a {{JSxRef("Boolean","boolean")}} indicating if there is some audio associated with the video.</dd>
</dl>

<h3 id="Microsoft_Extensions">Microsoft Extensions</h3>

<dl>
 <dt>{{DOMxRef("HTMLVideoElement.msFrameStep()")}} {{Non-standard_Inline}}</dt>
 <dd>Steps the video by one frame forward or one frame backward.</dd>
 <dt>{{DOMxRef("HTMLVideoElement.msHorizontalMirror")}} {{Non-standard_Inline}}</dt>
 <dd>Gets or sets whether a video element is flipped horizontally in the display.</dd>
 <dt>{{DOMxRef("HTMLVideoElement.msInsertVideoEffect()")}} {{Non-standard_Inline}}</dt>
 <dd>Inserts the specified video effect into the media pipeline.</dd>
 <dt>{{DOMxRef("HTMLVideoElement.msIsLayoutOptimalForPlayback")}} {{Non-standard_Inline}}{{ReadOnlyInline}}</dt>
 <dd>Indicates whether the video can be rendered more efficiently.</dd>
 <dt>{{DOMxRef("HTMLVideoElement.msIsStereo3D")}} {{Non-standard_Inline}}{{ReadOnlyInline}}</dt>
 <dd>Determines whether the system considers the loaded video source to be stereo 3-D or not. Value set to true indicates source is stereo 3D.</dd>
 <dt>{{DOMxRef("HTMLVideoElement.msZoom")}} {{Non-standard_Inline}}</dt>
 <dd>Controls whether the video frame is trimmed to fit the video display.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>Inherits methods from its parent, {{domxref("HTMLMediaElement")}}, and from its ancestor {{domxref("HTMLElement")}}.</em></p>

<dl>
 <dt>{{domxref("HTMLVideoElement.getVideoPlaybackQuality()")}} {{experimental_inline}}</dt>
 <dd>Returns a {{domxref("VideoPlaybackQuality")}} object that contains the current playback metrics. This information includes things like the number of dropped or corrupted frames, as well as the total number of frames.</dd>
 <dt>{{DOMxRef("HTMLVideoElement.requestPictureInPicture()")}}</dt>
 <dd>Requests that the user agent make video enters picture-in-picture mode</dd>
</dl>

<h2 id="Events">Events</h2>

<p><em>Inherits events from its parent, {{domxref("HTMLMediaElement")}}, and from its ancestor {{domxref("HTMLElement")}}. </em>Listen to these events using <code><a href="/en-US/docs/Web/API/EventTarget/addEventListener">addEventListener()</a></code> or by assigning an event listener to the <code>on<em>eventname</em></code> property of this interface.</p>

<dl>
  <dt>{{DOMxRef("HTMLVideoElement.enterpictureinpicture_event", "enterpictureinpicture")}}</dt>
  <dd>Sent to a {{DOMxRef("HTMLVideoElement")}} when it enters Picture-in-Picture mode. The associated event handler is {{DOMxRef("HTMLVideoElement.onenterpictureinpicture")}}</dd>
  <dt>{{DOMxRef("HTMLVideoElement.leavepictureinpicture_event", "leavepictureinpicture")}}</dt>
  <dd>Sent to a {{DOMxRef("HTMLVideoElement")}} when it leaves Picture-in-Picture mode. The associated event handler is {{DOMxRef("HTMLVideoElement.onleavepictureinpicture")}}</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "#htmlvideoelement", "HTMLVideoElement")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HTMLVideoElement")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>HTML element implementing this interface: {{HTMLElement("video")}}.</li>
 <li><a class="external" href="http://people.mozilla.org/~cpearce/paint-stats-demo.html">Demo of video paint statistics</a></li>
 <li><a href="/en-US/docs/HTML/Supported_media_formats">Supported media formats</a></li>
</ul>
